package ui;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.io.*;

import javax.imageio.ImageIO;
import javax.swing.*;
import javax.swing.event.*;

import controller.ApplicationController;

import model.*;

import zuozuomu.filter.*;

public class ApplicationView extends BambooView {
	private ApplicationController controller;

	private JFileChooser fileChooser = new JFileChooser();

	private JpegWatermarkFilter jpegWatermarkFilter = new JpegWatermarkFilter();

	private PngFilter pngFilter = new PngFilter();

	private AtfFilter atfFilter = new AtfFilter();

	private ModelFilter modelFilter = new ModelFilter();

	private JpegFilter jpegFilter = new JpegFilter();

//	private Graphics g = null;
	private Graphics2D g = null;

	public ApplicationView(final ApplicationController controller,
			final BambooModel model) {
		super(controller, model);
		this.controller = controller;
		fileChooser.setAcceptAllFileFilterUsed(false);
	}

	public BufferedImage createSaveImage() {
		/* ͈͂IĂꍇ */
		if (controller.isRegion()) {
			Dimension d = controller.getSaveRegion();
			BufferedImage image = createImage(d);
			controller.write(g);
			return createSaveImage(image, d);
		} else { // ͈͂IĂȂꍇ
			Dimension d = controller.getSaveSquare();
			BufferedImage image = createImage(d);
			controller.write(g);
			return createSaveImage(image, d);
		}

	}

	/**
	 * t@Cɉ摜ۑ
	 * 
	 * @param file
	 * @param suffix
	 *            pngjpeg
	 */
	public void saveImage(File file, String suffix) {
		BufferedImage saveImage = createSaveImage();
		try {
			ImageIO.write(saveImage, suffix, file);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	protected BufferedImage createImage(Dimension d) {
		return createImage(d.width, d.height);
	}

	protected BufferedImage createImage(int width, int height) {
		BufferedImage image = new BufferedImage(width, height,
				BufferedImage.TYPE_INT_RGB);

		g = image.createGraphics();

		g.setColor(Color.WHITE);
		g.fillRect(0, 0, width, height);

		return image;
	}

	protected BufferedImage createSaveImage(BufferedImage image, int width,
			int height) {

		g.dispose();

		BufferedImage saveImage = new BufferedImage(width + indent * 2, height
				+ indent * 2, BufferedImage.TYPE_INT_RGB);
		g = saveImage.createGraphics();
		g.fillRect(0, 0, width + indent * 2, height + indent * 2);
		g.drawImage(image, indent, indent, null);

		return saveImage;
	}

	protected BufferedImage createSaveImage(BufferedImage image, Dimension d) {
		return createSaveImage(image, d.width, d.height);
	}

	@Override
	/** ̃pl */
	protected JPanel upperPanel() {
		JPanel upperPanel = new JPanel(new BorderLayout());
		JToolBar toolBar = new JToolBar(); // c[o[
		toolBar.setFloatable(false); // ΂Ȃ悤ɂ
		toolBar.setFocusable(false);
		// VK쐬{^̐ݒ
		JButton newButton = new JButton(new ImageIcon(getClass().getResource(
				"new.gif")));
		newButton.setToolTipText("VK쐬");
		newButton.addActionListener(new NewListener());
		newButton.setFocusable(false);
		toolBar.add(newButton);
		// J{^̐ݒ
		JButton openButton = new JButton(new ImageIcon(getClass().getResource(
				"open.gif")));
		openButton.setToolTipText("J");
		openButton.setFocusable(false);
		openButton.addActionListener(new OpenListener());
		toolBar.add(openButton);
		// ۑ{^̐ݒ
		JButton saveImageButton = new JButton(new ImageIcon(getClass()
				.getResource("save.gif")));// ۑ
		saveImageButton.setToolTipText("ۑ");
		saveImageButton.setFocusable(false);
		saveImageButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				((ApplicationController) controller).save();
			}
		});
		toolBar.add(saveImageButton);
		// URL{^̐ݒ
		JButton urlButton = new JButton("URL");
		urlButton.setToolTipText("URL");
		urlButton.setFocusable(false);
		urlButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.url();
			}
		});
		toolBar.add(urlButton);

		// URL{^3̐ݒ
		JButton urlButton3 = new JButton("URL3");
		urlButton3.setToolTipText("URL3");
		urlButton3.setFocusable(false);
		urlButton3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				controller.url3();
			}
		});
		toolBar.add(urlButton3);

		upperPanel.add(toolBar, BorderLayout.WEST);
		// C[{^Ȃǂ̃pl
//		upperPanel.add(getCommonButtonPanel());
		// bN{^pl
		upperPanel.add(new LockButtonPanel(controller));
		// TCYx̐ݒ
		upperPanel.add(sizeLabel(), BorderLayout.EAST);
		return upperPanel;
	}

	// VK쐬
	private class NewListener implements ActionListener {
		private JDialog dialog;

		private JSpinner spinner;

		private JSpinner sizeSpinner;

		private int masu = 20;

		public void actionPerformed(ActionEvent e) {
			dialog = new JDialog(getFrame(), "VK쐬", true);
			JPanel panel = new JPanel(new GridLayout(2, 2));

			JLabel masuLabel = new JLabel("ӂ̃}Xڂ̐");
			panel.add(masuLabel);

			final SpinnerNumberModel masuModel = new SpinnerNumberModel(20, 1,
					1000, 1);
			spinner = new JSpinner(masuModel);
			final SpinnerNumberModel sizeModel = new SpinnerNumberModel(24, 1,
					24, 1);
			sizeSpinner = new JSpinner(sizeModel);
			spinner.addChangeListener(new ChangeListener() {
				public void stateChanged(ChangeEvent e) {
					masu = masuModel.getNumber().intValue();
					if (masu <= 25) {
						sizeModel.setValue(new Integer(24));
					} else {
						int size = 600 / masu;
						sizeModel.setValue(new Integer(size));
					}

				}
			});
			panel.add(spinner);

			JLabel sizeLabel = new JLabel("}X̃sNZ");
			panel.add(sizeLabel);
			panel.add(sizeSpinner);

			dialog.add(panel);

			JButton button = new JButton("OK");
			button.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					int size = sizeModel.getNumber().intValue();
					disposeFrame();
					controller.newFrame(masu, size);
				}
			});
			dialog.add(button, BorderLayout.SOUTH);
			dialog.pack();
			Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
			dialog.setLocation((screenSize.width - dialog.getWidth()) / 2,
					(screenSize.height - dialog.getHeight()) / 2); // \ʒu𒲐
			dialog.setVisible(true);
		}
	}

	private class OpenListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			fileChooser.resetChoosableFileFilters();
			fileChooser.addChoosableFileFilter(jpegWatermarkFilter);
			fileChooser.addChoosableFileFilter(pngFilter);
			fileChooser.addChoosableFileFilter(atfFilter);
			fileChooser.addChoosableFileFilter(modelFilter); // tB^[
			fileChooser.setFileFilter(jpegWatermarkFilter);

			/* f[^ǂݍ */
			fileChooser.setDialogTitle("|܂f[^ǂݍ *.jpeg *png *.atf *.dat"); // ^Cg
			int returnVal = fileChooser.showOpenDialog(getFrame());

			if (returnVal == JFileChooser.APPROVE_OPTION) {
				File file = fileChooser.getSelectedFile();
				if (!file.exists()) {
					return;
				}
				String fileName = file.getPath(); // tpX̃t@C𓾂
				/* ܂tB^[Ɋ֌WȂgqʂ̃t@CԂ */
				String[] format = { "png", "jpeg", "atf", "dat" };
				if (!isAllowedFormat(fileName, format)) {
					return;
				}

				if (endsWithIgnoreCase(fileName, "atf")) {
//					disposeFrame();
					controller.loadAtf(file);
				} else if (endsWithIgnoreCase(fileName, "dat")) {
					controller.loadDat(file);
				} else if (endsWithIgnoreCase(fileName, "jpeg")
						|| endsWithIgnoreCase(fileName, "png")) {
					disposeFrame();
					controller.decode(file);
				}
				controller.newModel();
			}
		}
	}

	public String save() {
		fileChooser.resetChoosableFileFilters(); // t@CtB^[Zbg
		/* tB^[Iђ */
		fileChooser.setDialogTitle("|܂t@Cۑ"); // ^Cg
		fileChooser.addChoosableFileFilter(jpegWatermarkFilter); // JPEGtB^
		fileChooser.addChoosableFileFilter(pngFilter); // PNGtB^
		fileChooser.addChoosableFileFilter(jpegFilter); // tB^[
		fileChooser.addChoosableFileFilter(atfFilter);
		fileChooser.addChoosableFileFilter(modelFilter); // tB^[
		fileChooser.setFileFilter(jpegWatermarkFilter); // ܂JPEGtB^

		int returnVal = fileChooser.showSaveDialog(getFrame()); // ʒɕ\
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File file = fileChooser.getSelectedFile();
			String fileName = file.getPath(); // tpX̃t@C𓾂

			/* ܂tB^[Ɋ֌WȂgqʂ̃t@CԂ */
			String[] format = { "png", "jpg", "jpeg", "atf", "dat" };
			if (isAllowedFormat(fileName, format))
				return fileName;

			// t@CYȂꍇ
			if (fileChooser.getFileFilter() instanceof JpegFilter) {
				fileName += ".jpg";
				return fileName;
			} else if (fileChooser.getFileFilter() instanceof AtfFilter) {
				fileName += ".atf";
				return fileName;
			} else if (fileChooser.getFileFilter() instanceof ModelFilter) {
				fileName += ".dat";
				return fileName;
			} else if (fileChooser.getFileFilter() instanceof JpegWatermarkFilter) {
				fileName += ".jpeg";
				return fileName;
			} else if (fileChooser.getFileFilter() instanceof PngFilter) {
				fileName += ".png";
				return fileName;
			}
		}
		return null;
	}

	protected boolean isAllowedFormat(String fileName, String[] suffix) {
		String lowerName = fileName.toLowerCase(); // ₷Ŝp
		for (int i = 0; i < suffix.length; i++) {
			if (lowerName.endsWith("." + suffix[i]))
				return true;
		}

		return false;
	}

	protected boolean endsWithIgnoreCase(String str1, String suffix) {
		String lowerName = str1.toLowerCase();
		if (lowerName.endsWith("." + suffix)) {
			return true;
		}
		return false;
	}

	@Override
	protected void processKey(KeyEvent e) {
		super.processKey(e);
		int keyCode = e.getKeyCode();
		switch (keyCode) {
		case KeyEvent.VK_S:
			if (e.isControlDown()) {
				/* Ctrl-S ŃZ[u */
				controller.save();
			} else {
				controller.setBamboo("horizontal");
			}
			break;
		}
	}
}
